#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GridGroupingRebind
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private const string connection = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source=""{0}"";Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False";
		
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			// Debug helpers to see when objects are created and destroyed (work only for debug builds
			// of libraries).
			Syncfusion.Grouping.RelationDescriptorCollection.VerboseEnsureInitialized = true;
			Syncfusion.Grouping.Engine.VerboseEnsureObjectLifeTime = true;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			System.Drawing.Icon ico = new System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
			this.Icon = ico ;	

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridGroupingControl1.Location = new System.Drawing.Point(0, 0);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(848, 329);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem10});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4,
																					  this.menuItem9,
																					  this.menuItem7,
																					  this.menuItem6,
																					  this.menuItem8,
																					  this.menuItem5});
			this.menuItem1.Text = "File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Products";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Customer Orders";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Customer Orders Details";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 3;
			this.menuItem9.Text = "Reset DataSource";
			this.menuItem9.Click += new System.EventHandler(this.menuItem9_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 4;
			this.menuItem7.Text = "-";
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 5;
			this.menuItem6.Text = "Grid Properties";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 6;
			this.menuItem8.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 7;
			this.menuItem5.Text = "Exit";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 1;
			this.menuItem10.Text = "About";
			this.menuItem10.Click += new System.EventHandler(this.menuItem10_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(848, 329);
			this.Controls.Add(this.gridGroupingControl1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "GridGroupingRebind...";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		string FindDatabase(string mdbFileName)
		{
			for (int n = 0; n < 10; n++)
			{
				if (System.IO.File.Exists(mdbFileName))
				{
					return mdbFileName;
				}
				mdbFileName = @"..\" + mdbFileName;
			}
			return "";
		}
		private DataSet queryOleDb(string name, string query)
		{
			DataSet ds = new DataSet();
			string mdbFileName = FindDatabase(@"Data\Northwind.mdb");
			if (connection != null && connection.Length > 0 &&
				query != null && query.Length > 0)
			{
				OleDbConnection conn = new OleDbConnection(String.Format(Form1.connection, mdbFileName));
				OleDbDataAdapter adapter = new OleDbDataAdapter();
				adapter.SelectCommand = new OleDbCommand(query, conn);
				adapter.Fill(ds);
				ds.Tables[0].TableName = name;
				conn.Close();
			}
			return ds;
		}

		private void BindData(DataSet ds)
		{
			this.gridGroupingControl1.SuspendLayout();

			this.gridGroupingControl1.DataSource = ds != null ? ds.Tables[0] : null;
			
			// Making columns marked readonly below, marks the schema as modified. Once 
			// a schema is marked modified, its setting stay even when the source list is changed.
			// This is by design and allows users to swap the datasource at runtime without having
			// to worry that manual changes to the schema are lost.
			//
			// In order to Reset the main table descriptor and also the nested relations
			// use the following two lines:
			this.gridGroupingControl1.ResetTableDescriptor();
			this.gridGroupingControl1.TableDescriptor.Relations.Reset();

			// Show group area
			this.gridGroupingControl1.ShowGroupDropArea = true;

			// Additionial table descriptors currently habe to be added manually. We
			// plan to provide a TableDescriptor.ShowInGroupDropArea property later
			// to make this easier.
			AddGroupDropAreas(this.gridGroupingControl1.Table);

			// Make changes to schema. See above notes how to reset changes.
			SetReadOnly(this.gridGroupingControl1.Table);

			this.gridGroupingControl1.ResumeLayout(true);
		}

		private void AddGroupDropAreas(GridTable table)
		{
			Syncfusion.Grouping.RelationDescriptor rd = table.TableDescriptor.ParentRelation;
			if (rd != null && rd.RelationKind != Syncfusion.Grouping.RelationKind.RelatedMasterDetails)
				return;

			foreach(GridTable t in table.RelatedTables)
			{
				Console.WriteLine("AddGroupDropArea " + t.Info);

				gridGroupingControl1.AddGroupDropArea(t);
				//recurse...
				AddGroupDropAreas(t);
			}
		}

		private void SetReadOnly(GridTable table)
		{
			table.TableDescriptor.AllowNew = false;
			table.TableDescriptor.AllowEdit = false;
			table.TableDescriptor.AllowRemove = false;
			
			//recurse...
			foreach(GridTable t in table.RelatedTables)
			{
				SetReadOnly(t);
			}
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			DataSet ds = queryOleDb("Products", "SELECT * FROM PRODUCTS");
			if( ds != null && ds.Tables.Count>0 )
			{
				BindData(ds);
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			DataSet ds = queryOleDb("Customers", "SELECT * FROM CUSTOMERS");
			DataSet ds2 = queryOleDb("Orders", "SELECT * FROM ORDERS");
			if( ds != null && ds.Tables.Count>0 && ds2 != null && ds2.Tables.Count>0 )
			{
				ds.Merge(ds2.Tables[0]);
				
				DataRelation relation = new DataRelation("CustomerOrders", 
					ds.Tables["Customers"].Columns["CustomerID"], 
					ds.Tables["Orders"].Columns["CustomerID"]);
				ds.Relations.Add(relation);

				BindData(ds);
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			DataSet ds = queryOleDb("Customers", "SELECT * FROM CUSTOMERS");
			DataSet ds2 = queryOleDb("Orders", "SELECT * FROM ORDERS");
			DataSet ds3 = queryOleDb("OrderDetails", "SELECT * FROM [ORDER DETAILS]");
			if( ds != null && ds.Tables.Count>0 && 
				ds2 != null && ds2.Tables.Count>0 && 
				ds3 != null && ds3.Tables.Count>0 )
			{
				ds.Merge(ds2.Tables[0]);
				ds.Merge(ds3.Tables[0]);
				
				DataRelation relation = new DataRelation("CustomerOrders", 
					ds.Tables["Customers"].Columns["CustomerID"], 
					ds.Tables["Orders"].Columns["CustomerID"]);
				ds.Relations.Add(relation);

				DataRelation relation2 = new DataRelation("OrderOrderDetails", 
					ds.Tables["Orders"].Columns["OrderID"], 
					ds.Tables["OrderDetails"].Columns["OrderID"]);
				ds.Relations.Add(relation2);

				BindData(ds);
			}
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void menuItem6_Click(object sender, System.EventArgs e)
		{
			GroupingGridPropertyDialog dlg = new GroupingGridPropertyDialog(this.gridGroupingControl1);
			dlg.Show();
		}

		private void menuItem9_Click(object sender, System.EventArgs e)
		{
			BindData(null);
		}

		private void menuItem10_Click(object sender, System.EventArgs e)
		{
//			DemoCommon.AboutForm abtForm=new DemoCommon.AboutForm(AppDomain.CurrentDomain.GetAssemblies());
//			abtForm.ShowDialog();
		}
	}
}
